--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    22:52:38 04/07/05
-- Design Name:    
-- Module Name:    block - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity block_mem is
    Port ( clk : in std_logic;
           reset : in std_logic;
           write_en : in std_logic;
			  writeaddr: in std_logic_vector(10 downto 0);
			  readaddr: in std_logic_vector(10 downto 0);
           data_in : in std_logic_vector(17 downto 0);
           data_out : out std_logic_vector(17 downto 0);
           read_en : in std_logic);
end block_mem;

architecture Behavioral of block_mem is

TYPE MEM IS ARRAY(0 to 1499) of std_logic_vector(17 downto 0);    
signal ram_block: MEM;

begin

read: process (clk)
begin
	if rising_edge(clk) then
		if (read_en='1') then
			data_out<=ram_block(conv_integer(unsigned(readaddr)));
		end if;
	end if;
end process;

write: process(clk)
begin
	if rising_edge(clk) then
		if (write_en='1') then
			ram_block(conv_integer(unsigned(writeaddr)))<=data_in;
		end if;
	end if;
end process;




end Behavioral;
